"list.to.grid"<-
function(out, grid)
{
	ind <- unlist(lapply(grid, length))	#	print(ind)
	if(count(ind > 1) > 2) {
		stop("Only two components can have more than one\nvalue in the grid list"
			)
	}
	nl <- length(grid)
	what <- (1:nl)[ind > 1]
	x1 <- grid[[what[1]]]
	x2 <- grid[[what[2]]]
	nr <- length(x1) * length(x2)
	xg <- matrix(NA, ncol = nl, nrow = nr)
	xg[, what] <- make.grid(x1, x2)
	for(k in 1:nl) {
		if(ind[k] == 1) {
			xg[, k] <- rep(grid[[k]], nr)
		}
	}
	class(xg) <- "surface.grid"
	attribute(xg, "names") <- names(grid)
	attribute(xg, "what") <- what
	attribute(xg, "x") <- x1
	attribute(xg, "y") <- x2
	xg
}
